module.exports = {
  'accessor-pairs': 'off',
  'array-bracket-spacing': 'error',
  'array-callback-return': ['error', { allowImplicit: true }],
  'array-element-newline': ['error', 'consistent'],
  'arrow-body-style': ['error', 'as-needed', {
    requireReturnForObjectLiteral: false,
  }],
  'arrow-parens': ['error', 'as-needed', {
    requireForBlockBody: true,
  }],
  'arrow-spacing': 'error',
  'block-scoped-var': 'error',
  'block-spacing': 'error',
  'brace-style': ['error', '1tbs', { allowSingleLine: true }],
  'callback-return': 'off',
  camelcase: 'error',
  'capitalized-comments': [
    'error',
    'always',
    {
      ignorePattern: 'pragma|ignored',
      ignoreInlineComments: true
    }
  ],
  'class-methods-use-this': 'error',
  'comma-dangle': 'error',
  'comma-spacing': 'error',
  'comma-style': ['error', 'last'],
  complexity: ['error', { max: 20 }],
  'computed-property-spacing': 'error',
  'consistent-return': 'error',
  'consistent-this': 'off',
  'constructor-super': 'error',
  curly: ['error', 'all'],
  'default-case': 'error',
  'dot-location': ['error', 'property'],
  'dot-notation': ['error', { allowKeywords: true }],
  'eol-last': 'error',
  eqeqeq: 'error',
  'for-direction': 'error',
  'func-call-spacing': 'error',
  'func-name-matching': ['error', 'always'],
  'func-names': ['error', 'always'],
  'func-style': ['error', 'declaration'],
  'function-paren-newline': ['error', 'consistent'],
  'generator-star-spacing': 'error',
  'getter-return': ['error', { allowImplicit: true }],
  'global-require': 'error',
  'guard-for-in': 'error',
  'handle-callback-err': 'error',
  'id-blacklist': 'off',
  'id-length': 'off',
  'id-match': 'off',
  'implicit-arrow-linebreak': ['error', 'beside'],
  indent: ['error', 4],
  'indent-legacy': ['error', 4, { SwitchCase: 2 }],
  'init-declarations': 'off',
  'jsx-quotes': 'off',
  'key-spacing': ['error', { beforeColon: false, afterColon: true }],
  'keyword-spacing': ['error', {
    before: true,
    after: true,
    overrides: {
      return: { after: true },
      throw: { after: true },
      case: { after: true }
    }
  }],
  'line-comment-position': ['error', { position: 'above' }],
  'linebreak-style': ['error', 'unix'],
  'lines-around-comment': ['error', {
    beforeBlockComment: true,
    afterBlockComment: false,
    beforeLineComment: true,
    afterLineComment: false
  }],
  'lines-around-directive': ['error', 'always'],
  'lines-between-class-members': ['error', 'always'],
  'max-classes-per-file': ['error', 2],
  'max-depth': ['off', 4],
  'max-len': ['error', 160, {
    ignoreComments: true,
    ignoreUrls: true,
    ignoreStrings: true,
    ignoreTemplateLiterals: true,
    ignoreRegExpLiterals: true
  }],
  'max-lines': ['off', {
    max: 300,
    skipBlankLines: true,
    skipComments: true
  }],
  'max-lines-per-function': ['off', {
    max: 50,
    skipBlankLines: true,
    skipComments: true,
    IIFEs: true,
  }],
  'max-nested-callbacks': ['error', { max: 2 }],
  'max-params': ['warn', 3],
  'max-statements': 'off',
  'max-statements-per-line': 'error',
  'multiline-comment-style': 'off',
  'multiline-ternary': 'off',
  'new-cap': 'error',
  'new-parens': 'error',
  'newline-after-var': 'off',
  'newline-before-return': 'error',
  'newline-per-chained-call': ['error', { ignoreChainWithDepth: 2 }],
  'no-alert': 'error',
  'no-array-constructor': 'error',
  'no-async-promise-executor': 'error',
  'no-await-in-loop': 'error',
  'no-bitwise': 'error',
  'no-buffer-constructor': 'error',
  'no-caller': 'error',
  'no-case-declarations': 'error',
  'no-catch-shadow': 'error',
  'no-class-assign': 'error',
  'no-compare-neg-zero': 'error',
  'no-cond-assign': 'error',
  'no-confusing-arrow': ['error', {
    allowParens: true,
  }],
  'no-console': 'error',
  'no-const-assign': 'error',
  'no-constant-condition': 'error',
  'no-continue': 'error',
  'no-control-regex': 'error',
  'no-debugger': 'error',
  'no-delete-var': 'error',
  'no-div-regex': 'off',
  'no-dupe-args': 'error',
  'no-dupe-class-members': 'error',
  'no-dupe-keys': 'error',
  'no-duplicate-case': 'error',
  'no-duplicate-imports': 'error',
  'no-else-return': ['error', { allowElseIf: false }],
  'no-empty': 'error',
  'no-empty-character-class': 'error',
  'no-empty-function': 'error',
  'no-empty-pattern': 'error',
  'no-eq-null': 'error',
  'no-eval': 'error',
  'no-ex-assign': 'error',
  'no-extend-native': 'error',
  'no-extra-bind': 'error',
  'no-extra-boolean-cast': 'error',
  'no-extra-label': 'error',
  'no-extra-parens': 'off',
  'no-extra-semi': 'error',
  'no-fallthrough': 'error',
  'no-floating-decimal': 'error',
  'no-func-assign': 'error',
  'no-global-assign': 'error',
  'no-implicit-coercion': 'off',
  'no-implicit-globals': 'off',
  'no-implied-eval': 'error',
  'no-inline-comments': 'off',
  'no-inner-declarations': 'error',
  'no-invalid-regexp': 'error',
  'no-invalid-this': 'off',
  'no-irregular-whitespace': 'error',
  'no-iterator': 'error',
  'no-label-var': 'error',
  'no-labels': 'error',
  'no-lone-blocks': 'error',
  'no-lonely-if': 'error',
  'no-loop-func': 'error',
  'no-magic-numbers': 'error',
  'no-misleading-character-class': 'error',
  'no-mixed-operators': 'error',
  'no-mixed-require': 'off',
  'no-mixed-spaces-and-tabs': 'error',
  'no-multi-assign': 'error',
  'no-multi-spaces': 'error',
  'no-multi-str': 'error',
  'no-multiple-empty-lines': ['error', { max: 2, maxBOF: 0, maxEOF: 0 }],
  'no-native-reassign': 'error',
  'no-negated-condition': 'off',
  'no-negated-in-lhs': 'off',
  'no-nested-ternary': 'error',
  'no-new': 'error',
  'no-new-func': 'error',
  'no-new-object': 'error',
  'no-new-require': 'error',
  'no-new-symbol': 'error',
  'no-new-wrappers': 'error',
  'no-obj-calls': 'error',
  'no-octal': 'error',
  'no-octal-escape': 'error',
  'no-param-reassign': 'error',
  'no-path-concat': 'error',
  'no-plusplus': ['error', { allowForLoopAfterthoughts: true }],
  'no-process-env': 'off',
  'no-process-exit': 'off',
  'no-proto': 'error',
  'no-prototype-builtins': 'error',
  'no-redeclare': 'error',
  'no-regex-spaces': 'error',
  'no-restricted-globals': ['error',
    'addEventListener',
    'blur',
    'close',
    'closed',
    'confirm',
    'defaultStatus',
    'event',
    'external',
    'defaultstatus',
    'find',
    'focus',
    'frameElement',
    'frames',
    'history',
    'innerHeight',
    'innerWidth',
    'length',
    'location',
    'locationbar',
    'menubar',
    'moveBy',
    'moveTo',
    'name',
    'onblur',
    'onerror',
    'onfocus',
    'onload',
    'onresize',
    'onunload',
    'open',
    'opener',
    'opera',
    'outerHeight',
    'outerWidth',
    'pageXOffset',
    'pageYOffset',
    'parent',
    'print',
    'removeEventListener',
    'resizeBy',
    'resizeTo',
    'screen',
    'screenLeft',
    'screenTop',
    'screenX',
    'screenY',
    'scroll',
    'scrollbars',
    'scrollBy',
    'scrollTo',
    'scrollX',
    'scrollY',
    'self',
    'status',
    'statusbar',
    'stop',
    'toolbar',
    'top',
  ],
  'no-restricted-imports': ['off', {
    paths: [],
    patterns: []
  }],
  'no-restricted-modules': 'off',
  'no-restricted-properties': ['error', { property: 'substring', message: 'Use .slice instead of .substring.' }, { property: 'substr', message: 'Use .slice instead of .substr.' }, { object: 'assert', property: 'equal', message: 'Use assert.strictEqual instead of assert.equal.' }, { object: 'assert', property: 'notEqual', message: 'Use assert.notStrictEqual instead of assert.notEqual.' }, { object: 'assert', property: 'deepEqual', message: 'Use assert.deepStrictEqual instead of assert.deepEqual.' }, { object: 'assert', property: 'notDeepEqual', message: 'Use assert.notDeepStrictEqual instead of assert.notDeepEqual.' }],
  'no-restricted-syntax': 'error',
  'no-return-assign': ['error', 'always'],
  'no-return-await': 'error',
  'no-script-url': 'error',
  'no-self-assign': 'error',
  'no-self-compare': 'error',
  'no-sequences': 'error',
  'no-shadow': 'error',
  'no-shadow-restricted-names': 'error',
  'no-sparse-arrays': 'error',
  'no-sync': 'off',
  'no-tabs': 'error',
  'no-template-curly-in-string': 'error',
  'no-ternary': 'off',
  'no-this-before-super': 'error',
  'no-throw-literal': 'error',
  'no-trailing-spaces': 'error',
  'no-undef': ['error', { typeof: true }],
  'no-undef-init': 'error',
  'no-undefined': 'off',
  'no-underscore-dangle': ['error', { allowAfterThis: true }],
  'no-unexpected-multiline': 'error',
  'no-unmodified-loop-condition': 'error',
  'no-unneeded-ternary': 'error',
  'no-unreachable': 'error',
  'no-unsafe-finally': 'error',
  'no-unsafe-negation': 'error',
  'no-unused-expressions': 'error',
  'no-unused-labels': 'error',
  'no-unused-vars': ['error', { vars: 'all', args: 'after-used', ignoreRestSiblings: true }],
  'no-use-before-define': ['error', { functions: true, classes: true, variables: true }],
  'no-useless-call': 'error',
  'no-useless-catch': 'error',
  'no-useless-computed-key': 'error',
  'no-useless-concat': 'error',
  'no-useless-constructor': 'error',
  'no-useless-escape': 'error',
  'no-useless-rename': 'error',
  'no-useless-return': 'error',
  'no-var': 'error',
  'no-void': 'error',
  'no-warning-comments': ['off', { terms: ['todo', 'fixme', 'xxx'], location: 'start' }],
  'no-whitespace-before-property': 'error',
  'no-with': 'error',
  'nonblock-statement-body-position': 'off',
  'object-curly-newline': ['error', { consistent: true, multiline: true }],
  'object-curly-spacing': ['error', 'always'],
  'object-property-newline': ['error', { allowAllPropertiesOnSameLine: true }],
  'object-shorthand': 'error',
  'one-var': 'off',
  'one-var-declaration-per-line': 'error',
  'operator-assignment': 'error',
  'operator-linebreak': 'error',
  'padded-blocks': ['error', {
    blocks: 'never',
    classes: 'never',
    switches: 'never'
  }],
  'padding-line-between-statements': ['error', { blankLine: 'always', prev: ['const', 'let', 'var'], next: '*' }, { blankLine: 'any', prev: ['const', 'let', 'var'], next: ['const', 'let', 'var'] }],
  'prefer-arrow-callback': 'error',
  'prefer-const': 'error',
  'prefer-destructuring': 'error',
  'prefer-named-capture-group': 'warn',
  'prefer-numeric-literals': 'error',
  'prefer-object-spread': 'error',
  'prefer-promise-reject-errors': 'error',
  'prefer-rest-params': 'error',
  'prefer-spread': 'error',
  'prefer-template': 'error',
  'quote-props': 'error',
  quotes: ['error', 'single', { avoidEscape: true }],
  radix: 'error',
  'require-atomic-updates': 'off',
  'require-await': 'off',
  'require-jsdoc': 'off',
  'require-unicode-regexp': 'off',
  'require-yield': 'error',
  'rest-spread-spacing': 'off',
  semi: 'error',
  'semi-spacing': ['error', { before: false, after: true }],
  'semi-style': 'error',
  'sort-imports': ['error', {
    ignoreCase: false,
    ignoreDeclarationSort: false,
    ignoreMemberSort: false,
    memberSyntaxSortOrder: ['none', 'all', 'multiple', 'single']
  }],
  'sort-keys': 'off',
  'sort-vars': 'off',
  'space-before-blocks': 'error',
  'space-before-function-paren': ['error', {
    anonymous: 'always',
    named: 'never',
    asyncArrow: 'always'
  }],
  'space-in-parens': 'error',
  'space-infix-ops': 'error',
  'space-unary-ops': ['error', {
    words: true,
    nonwords: false,
    overrides: {
    },
  }],
  'spaced-comment': ['error', 'always', { exceptions: ['-'] }],
  strict: ['error', 'never'],
  'switch-colon-spacing': 'error',
  'symbol-description': 'error',
  'template-curly-spacing': 'error',
  'template-tag-spacing': 'error',
  'unicode-bom': 'error',
  'use-isnan': 'error',
  'valid-jsdoc': 'off',
  'valid-typeof': 'error',
  'vars-on-top': 'error',
  'wrap-iife': ['error', 'any'],
  'wrap-regex': 'off',
  'yield-star-spacing': 'error',
  yoda: ['error', 'never'],
};
